
CoCoA-5 - Bug #1273

NewPolyRing and SymbolRange together make a crash

29 Apr 2019 14:14 - John Abbott

Status: Closed Start date: 29 Apr 2019

Priority: High Due date:  

Assignee: John Abbott % Done: 100%

Category: bug Estimated time: 1.99 hour

Target version: CoCoA-5.3.0 Spent time: 1.65 hour

Description

The problem is with double indices.  Here is a small failing example:

vars := SymbolRange("a", [1,2],[1,2]);

P := NewPolyRing(QQ, vars); -->  BOOM!

 

The output of SymbolRange looks wrong anyway, but it should not cause a crash!

Note: reported by Julian Danner (Passau)

Related issues:

Related to CoCoA-5 - Feature #1290: NewPolyRing: allow symbols with just head... Closed 27 May 2019

Related to CoCoA-5 - Bug #1384: NewPolyRing and SymbolRange Closed 07 Jan 2020

History

#1 - 29 Apr 2019 14:18 - John Abbott

The SymbolRange impl looks very suspect.  It does not properly check its arg types.

Fn is defd in coclib.cpkg5.   Investigating & cleaning.

#2 - 29 Apr 2019 14:21 - John Abbott

- Status changed from New to Resolved

- Assignee set to John Abbott

- % Done changed from 0 to 50

One problem appears to be on line 46 of cocolib.cpkg5: replace [i] with just i.

#3 - 29 Apr 2019 18:21 - John Abbott

- % Done changed from 50 to 80

Another problem was in evalArgAsListOfSymbols which did a dynamic pointer cast and used the result without checking whether it was nullptr. 

Seems better now.

Note: reference Interpreter.C near line 136

#4 - 30 Apr 2019 10:35 - John Abbott

- Description updated

- Estimated time set to 1.99 h
I must get my CVS access sorted out, so I can check in.

#5 - 27 May 2019 13:22 - John Abbott

- Related to Feature #1290: NewPolyRing: allow symbols with just head and no indices? added

#6 - 04 Oct 2019 16:16 - Anna Maria Bigatti

Seems to work now, both on Mac and on Linux.

Close?

#7 - 10 Oct 2019 17:36 - John Abbott

- Target version changed from CoCoA-5.3.0 to CoCoA-5.4.2

- % Done changed from 80 to 100

#8 - 10 Oct 2019 19:30 - Anna Maria Bigatti

- Target version changed from CoCoA-5.4.2 to CoCoA-5.3.0

#9 - 13 Feb 2020 09:26 - Anna Maria Bigatti

- Status changed from Resolved to Closed

#10 - 13 Feb 2020 09:29 - Anna Maria Bigatti

- Related to Bug #1384: NewPolyRing and SymbolRange added
